--- asterisk-1.4.18.1/apps/app_dial.c~	2008-01-22 11:31:17.000000000 -0600
+++ asterisk-1.4.18.1/apps/app_dial.c	2008-04-07 20:34:21.000000000 -0600
@@ -105,6 +105,8 @@
 "however, the variable will be unset after use.\n\n"
 "  Options:\n"
 "    A(x) - Play an announcement to the called party, using 'x' as the file.\n"
+"    c    - Proceed with dialplan execution of the called party if the source\n"
+"           channel hangs up.\n"
 "    C    - Reset the CDR for this call.\n"
 "    d    - Allow the calling user to dial a 1 digit extension while waiting for\n"
 "           a call to be answered. Exit to that extension if it exists in the\n"
@@ -248,6 +250,7 @@
 	OPT_CALLEE_PARK =	(1 << 25),
 	OPT_CALLER_PARK =	(1 << 26),
 	OPT_IGNORE_FORWARDING = (1 << 27),
+	OPT_CALLEE_GO_ON =	(1 << 28),
 } dial_exec_option_flags;
 
 #define DIAL_STILLGOING			(1 << 30)
@@ -269,6 +272,7 @@
 
 AST_APP_OPTIONS(dial_exec_options, {
 	AST_APP_OPTION_ARG('A', OPT_ANNOUNCE, OPT_ARG_ANNOUNCE),
+	AST_APP_OPTION('c', OPT_CALLEE_GO_ON),
 	AST_APP_OPTION('C', OPT_RESETCDR),
 	AST_APP_OPTION('d', OPT_DTMF_EXIT),
 	AST_APP_OPTION_ARG('D', OPT_SENDDTMF, OPT_ARG_SENDDTMF),
@@ -1098,7 +1102,7 @@
 		outbound_group = pbx_builtin_getvar_helper(chan, "OUTBOUND_GROUP");
 	}
 	    
-	ast_copy_flags(peerflags, &opts, OPT_DTMF_EXIT | OPT_GO_ON | OPT_ORIGINAL_CLID | OPT_CALLER_HANGUP | OPT_IGNORE_FORWARDING);
+	ast_copy_flags(peerflags, &opts, OPT_DTMF_EXIT | OPT_CALLEE_GO_ON | OPT_GO_ON | OPT_ORIGINAL_CLID | OPT_CALLER_HANGUP | OPT_IGNORE_FORWARDING);
 	/* loop through the list of dial destinations */
 	rest = args.peers;
 	while ((cur = strsep(&rest, "&")) ) {
@@ -1720,7 +1724,7 @@
 			pbx_builtin_setvar_helper(chan, "DIALEDTIME", toast);
 		}
 		
-		if (res != AST_PBX_NO_HANGUP_PEER) {
+		if (!ast_test_flag(peerflags, OPT_CALLEE_GO_ON) && res != AST_PBX_NO_HANGUP_PEER) {
 			if (!chan->_softhangup)
 				chan->hangupcause = peer->hangupcause;
 			ast_hangup(peer);
